-- Name:PhanTime:Author:Phantasmagor
---------------------------------------------------------------------------------
-- Script PhanTime 

---------------------------------------------------------------------------------
-- GLOBALS
---------------------------------------------------------------------------------
Global("DRAG_AND_DROP_ID", 802)
Global("CONFIG_SECTION_NAME", "PhanTime")
-- Панели ----------------------------
Global( "wxMainPanel", nil )
Global( "wxTimerPanel", nil )
-- Текст ----------------------------
Global( "wtTimeText", nil )
Global( "wtTimerText", nil )
-- Кнопки ---------------------------
Global( "wbTimerButton", nil )
Global( "wbTimerActiveButton", nil )
Global( "wbPauseButton", nil )
Global( "wbPauseActiveButton", nil )
-- Other ---------------------------
Global( "Time" , {} )
Global( "Timer" , {} )
Global( "GotTime", false )
Global( "TimerShow", false )
Global( "TimerRun", false )


---------------------------------------------------------------------------------
---------------------------------------------------------------------------------
---------------------------------------------------------------------------------
--двигаем дочерние контроллы
function MoveAllUIElementsByForm()	
		local MainPanelPlacement = wxMainPanel:GetPlacementPlain()

		local TimerPanelPlacement = wxTimerPanel:GetPlacementPlain()
		TimerPanelPlacement.posX = MainPanelPlacement.posX
		TimerPanelPlacement.posY = MainPanelPlacement.posY + 35
		wxTimerPanel:SetPlacementPlain( TimerPanelPlacement )
end
---------------------------------------------------------------------------------
function PanelSetPlacementPlain( param, offset )

	local PanlePlacement = param:GetPlacementPlain()
	local MainPanelPlacement = wxMainPanel:GetPlacementPlain()

	PanlePlacement.posX = MainPanelPlacement.posX
	PanlePlacement.posY = MainPanelPlacement.posY + offset
	param:SetPlacementPlain( PanlePlacement )
	
end
---------------------------------------------------------------------------------
function TimeTextSetVal( wtparam, param )

	wtparam:SetVal( "hours", common.FormatInt( param.h , "%02d" ) )
	wtparam:SetVal( "minutes", common.FormatInt( param.m , "%02d" ) )
	wtparam:SetVal( "seconds", common.FormatInt( param.s , "%02d" ) )
	
end
---------------------------------------------------------------------------------
function TimeTextInit( wtparam, param )

	param.h = 0
	param.m = 0
	param.s = 0

	TimeTextSetVal( wtparam, param )

end
---------------------------------------------------------------------------------
function TimeCounter()

	if (Time.s == 59) then
		Time.s = 0
		if (Time.m == 59) then
			Time.m = 0
			if (Time.h == 23) then
				Time.h = 0
			else
				Time.h = Time.h + 1
			end
		else
			Time.m = Time.m + 1
		end
	else
		Time.s = Time.s + 1
	end

	TimeTextSetVal( wtTimeText, Time )
end
---------------------------------------------------------------------------------
function TimerCounter()

	if (Timer.s == 59) then
		Timer.s = 0
		if (Timer.m == 59) then
			Timer.m = 0
			Timer.h = Timer.h + 1
		else
			Timer.m = Timer.m + 1
		end
	else
		Timer.s = Timer.s + 1
	end

	TimeTextSetVal( wtTimerText, Timer )
end
---------------------------------------------------------------------------------
---------------------------------------------------------------------------------
---------------------------------------------------------------------------------
-- EVENT HANDLERS
---------------------------------------------------------------------------------
-- Включение панели таймера, Запуск таймера
function OnTimerButtonReaction( )

	TimeTextInit( wtTimerText, Timer )

	TimerShow = true
	TimerRun = true

	PanelSetPlacementPlain( wxTimerPanel, 35 )
	wxTimerPanel:Show( true )
	wbPauseButton:Show( true )
	wbPauseActiveButton:Show( false )

	wbTimerButton:Show( false )
	wbTimerActiveButton:Show( true )

end
---------------------------------------------------------------------------------
--Выключение панели таймера, Останов таймера
function OnTimerActiveButtonReaction( )

	TimerShow = false
	TimerRun = false

	wxTimerPanel:Show( false )
	wbTimerButton:Show( true )
	wbTimerActiveButton:Show( false )

	wbPauseButton:Show( false )
	wbPauseActiveButton:Show( false )


end
---------------------------------------------------------------------------------
-- Вкл. паузу
function OnPauseButtonReaction( )
	TimerRun = false;
	wbPauseButton:Show( false )
	wbPauseActiveButton:Show( true )
end
-- Выкл. паузу
function OnPauseActiveButtonReaction( )
	TimerRun = true;
	wbPauseButton:Show( true )
	wbPauseActiveButton:Show( false )
end
---------------------------------------------------------------------------------
-- При появлении сообщения в чате
function OnEventChatMessage( params )
		Time = params.time
		GotTime = true
end
---------------------------------------------------------------------------------
-- Каждую секунду
function OnEventSecondTimer( )

	if GotTime then TimeCounter() end
	if TimerRun then TimerCounter() end

end
---------------------------------------------------------------------------------
---------------------------------------------------------------------------------
---------------------------------------------------------------------------------
-- Drag&Drop
---------------------------------------------------------------------------------
function DNDInit(wtReacting, wtMovable, ID)	
	Global("DragNDrop", {})
	DragNDrop.ID = ID
	DragNDrop.wtReacting = wtReacting
	DragNDrop.wtMovable = wtMovable
	DragNDrop.IsPicked = false

	common.RegisterEventHandler(OnEventDNDPickAttempt, "EVENT_DND_PICK_ATTEMPT")
	common.RegisterEventHandler(OnEventDNDDragTo, "EVENT_DND_DRAG_TO")
	common.RegisterEventHandler(OnEventDNDDropAttempt, "EVENT_DND_DROP_ATTEMPT")
	DNDReg()
end
---------------------------------------------------------------------------------
function DNDReg()
	if DragNDrop then
		mission.DNDRegister(DragNDrop.wtReacting, DND_WIDGET_MOVE * DND_CONTAINER_STEP + DragNDrop.ID, true)
	end
end
---------------------------------------------------------------------------------
function DNDUnreg()
	if DragNDrop then
		mission.DNDUnregister(DragNDrop.wtReacting)
	end
end
---------------------------------------------------------------------------------
function OnEventDNDPickAttempt(params)	
	if math.mod(params.srcId, DND_CONTAINER_STEP) == DragNDrop.ID then	
		DragNDrop.Place = DragNDrop.wtMovable:GetPlacementPlain()
		DragNDrop.Screen = widgetsSystem:GetPosConverterParams()
		DragNDrop.DeltaX = math.ceil( params.posX * DragNDrop.Screen.fullVirtualSizeX / DragNDrop.Screen.realSizeX - DragNDrop.Place.posX )
		DragNDrop.DeltaY = math.ceil( params.posY * DragNDrop.Screen.fullVirtualSizeY / DragNDrop.Screen.realSizeY - DragNDrop.Place.posY )
		common.SetCursor("drag")
		DragNDrop.IsPicked = true
	end
end
---------------------------------------------------------------------------------
-- перемещение курсора во время drag&drop
function OnEventDNDDragTo(params)
	if DragNDrop.IsPicked then
		local FrameShadow = 8 -- Ширина тени по краям панелей. Тень можно задвинуть за край экрана. -- SLA.
		DragNDrop.Place.posX = math.ceil( params.posX * DragNDrop.Screen.fullVirtualSizeX / DragNDrop.Screen.realSizeX - DragNDrop.DeltaX )
		DragNDrop.Place.posY = math.ceil( params.posY * DragNDrop.Screen.fullVirtualSizeY / DragNDrop.Screen.realSizeY - DragNDrop.DeltaY )
		if DragNDrop.Place.posX < 0-FrameShadow then DragNDrop.Place.posX = 0-FrameShadow end
		if DragNDrop.Place.posY < 0-FrameShadow then DragNDrop.Place.posY = 0-FrameShadow end
		if DragNDrop.Place.posX + DragNDrop.Place.sizeX > DragNDrop.Screen.fullVirtualSizeX + FrameShadow then
			DragNDrop.Place.posX = DragNDrop.Screen.fullVirtualSizeX - DragNDrop.Place.sizeX + FrameShadow
		end
		if DragNDrop.Place.posY + DragNDrop.Place.sizeY > DragNDrop.Screen.fullVirtualSizeY + FrameShadow then
			DragNDrop.Place.posY = DragNDrop.Screen.fullVirtualSizeY - DragNDrop.Place.sizeY + FrameShadow
		end		
		DragNDrop.wtMovable:SetPlacementPlain(DragNDrop.Place)
		common.SetCursor("drag")
		--двигаем дочерние контроллы
		MoveAllUIElementsByForm()
	end
end
---------------------------------------------------------------------------------
-- попытка системы завершить drag&drop
function OnEventDNDDropAttempt(params)
	if DragNDrop.IsPicked then
		mission.DNDConfirmDropAttempt()
		common.SetCursor("default")
		DragNDrop.IsPicked = false
		-- Сохраняем координаты в файл конфигурации
		if not common.SetGlobalConfigSection then -- AO 1.1.02+
			userMods.SetGlobalConfigSection( CONFIG_SECTION_NAME, { x=DragNDrop.Place.posX, y=DragNDrop.Place.posY } )
		else -- Older AO (EU/US)
	 		common.SetGlobalConfigSection( CONFIG_SECTION_NAME, { x=DragNDrop.Place.posX, y=DragNDrop.Place.posY } )
		end
	end
end
---------------------------------------------------------------------------------
---------------------------------------------------------------------------------
---------------------------------------------------------------------------------
-- При скрытии интерфейса (ALT+Z)
function OnToggleUI( params )
	if params.visible then
		wxMainPanel:Show( true )
		if TimerShow then wxTimerPanel:Show( true ) end
		DNDReg()
	else
		wxMainPanel:Show( false )
		wxTimerPanel:Show( false )
		DNDUnreg()	
	end
end
---------------------------------------------------------------------------------
---------------------------------------------------------------------------------
---------------------------------------------------------------------------
-- INITIALIZATION
---------------------------------------------------------------------------------
function Init()

	-- сообщение в чате
	
	--common.RegisterEventHandler( OnEventChatMessage, "EVENT_CHAT_MESSAGE" )
	if avatar.GetQuestsLimit then
		Time = mission.GetWorldTimeHMS()
		GotTime = true
	else
		common.RegisterEventHandler( OnEventChatMessage, "EVENT_CHAT_MESSAGE" )
	end
	-- каждую секунду
	common.RegisterEventHandler( OnEventSecondTimer, "EVENT_SECOND_TIMER" )
	-- Регистрируем кнопочные события
	common.RegisterReactionHandler( OnTimerButtonReaction, "wbTimerButtonReaction" )
	common.RegisterReactionHandler( OnTimerActiveButtonReaction, "wbTimerActiveButtonReaction" )
	common.RegisterReactionHandler( OnPauseButtonReaction, "wbPauseButtonReaction")
	common.RegisterReactionHandler( OnPauseActiveButtonReaction, "wbPauseActiveButtonReaction")
	-- События drag&drop
	common.RegisterEventHandler( OnEventDNDPickAttempt, "EVENT_DND_PICK_ATTEMPT" )
	common.RegisterEventHandler( OnEventDNDDragTo, "EVENT_DND_DRAG_TO" )
	common.RegisterEventHandler( OnEventDNDDropAttempt, "EVENT_DND_DROP_ATTEMPT" )
	-- Скрывать по "ALT+Z"
	common.RegisterEventHandler( OnToggleUI, "SCRIPT_TOGGLE_UI")

	-- Синхронизируем время при старте
	if group.ChatSay then -- Fix for AO 1.1
		group.ChatSay( common.FormatInt( 0 , "%02d" ) )
	end
	
	-- Основная панель
	wxMainPanel = mainForm:GetChildChecked( "MainPanel", false )
	-- Получаем сохраненные координаты из файла конфигурации
	local AddonConfig
	if not common.GetGlobalConfigSection then -- AO 1.1.02+
		AddonConfig = userMods.GetGlobalConfigSection( CONFIG_SECTION_NAME )
	else -- Older AO (EU/US)
		AddonConfig = common.GetGlobalConfigSection( CONFIG_SECTION_NAME )
	end
	if AddonConfig and AddonConfig.x and AddonConfig.y then
		local MainPanelPlacement = wxMainPanel:GetPlacementPlain()
		MainPanelPlacement.posX = AddonConfig.x
		MainPanelPlacement.posY = AddonConfig.y
		wxMainPanel:SetPlacementPlain( MainPanelPlacement )
	end
	wxMainPanel:Show( true )

	-- Дополнительные панели
	wxTimerPanel = mainForm:GetChildChecked( "TimerPanel", false )
	wxTimerPanel:Show( false )

	-- Текст
	wtTimeText = wxMainPanel:GetChildChecked( "TimeText", false )
	wtTimerText = wxTimerPanel:GetChildChecked( "TimerText", false )
	
	-- Кнопки
	wbTimerButton = wxMainPanel:GetChildChecked( "wbTimerButton" , false )
	wbTimerActiveButton = wxMainPanel:GetChildChecked( "wbTimerActiveButton" , false )
	wbTimerActiveButton:Show( false )

	wbPauseButton = wxTimerPanel:GetChildChecked( "wbPauseButton" , false )
	wbPauseActiveButton = wxTimerPanel:GetChildChecked( "wbPauseActiveButton" , false )
	wbPauseActiveButton:Show( false )

	-- Зарегистрировать контролы для drag&drop
	DNDInit(wxMainPanel, wxMainPanel, DRAG_AND_DROP_ID)

end

--=============================================================================--

Init()

--=============================================================================--
